/*----------------------------------------------------------------------+
|									|
|  Copyright (c) 1985-93;  Bentley Systems, Inc., All rights reserved.	|
|									|
| "MicroStation", "MDL", and "MicroCSL" are trademarks of Bentley	|
|  Systems, Inc.							|
|									|
|  Limited permission is hereby granted to reproduce and modify this	|
|  copyrighted material provided that the resulting code is used only 	|
|  in conjunction with Bentley Systems products under the terms of the	|
|  license agreement provided therein, and that this notice is retained	|
|  in its entirety in any such reproduction or modification.		|
|									|
+----------------------------------------------------------------------*/
/*----------------------------------------------------------------------+
|									|
|   msvvr.fdf  --  Solver Variable
|									|
|   Current Revision:							|
|   $Workfile:   msvvr.fdf  $
|   $Revision:   6.1  $  $Date:   29 Jun 1995 14:26:26  $
|									|
+----------------------------------------------------------------------*/
#if !defined (__msvvrFDF__)
#define __msvvrFDF__

/*----------------------------------------------------------------------+
|									|
|   Header File Dependencies						|
|									|
+----------------------------------------------------------------------*/
#if !defined (__msslvrH__)
#   include <msslvr.h>		/* for Var */
#endif

#if   defined (__BSI__)
#include	<mivvr.fdf>
#endif

/*======================================================================+
|									|
|   Major Public Code Section						|
|									|
+======================================================================*/

/*-----------------------------------------------------------------------
		Create/use/destroy
-----------------------------------------------------------------------*/
extern  Var	*mdlVar_create
(				/* <= ptr to initialized Var object */
double    v                     /* => initial value */
);

extern void	mdlVar_use
(
Var		*pThis		/* <=> (use count incremented) */
);

extern void	mdlVar_destroy
(
Var		*pThis		/* <=> (use count decremented, freed?) */
);

/*-----------------------------------------------------------------------
		Value Access
-----------------------------------------------------------------------*/

extern Var      *mdlVar_setVal
(
Var             *pThis,
double          v
);

extern double   mdlVar_getVal
(
Var             *pThis
);

extern boolean	mdlVar_hasNoValue
(                               /* <= T/F */
Var             *pThis           /* => the variable */
);


extern	void	mdlVar_saveVal
(
Var		*pThis
);

extern	void	mdlVar_restoreVal
(
Var		*pThis
);


/*-----------------------------------------------------------------------
		Attribute Access
-----------------------------------------------------------------------*/

extern boolean	mdlVar_isUnderDetermined
(                               /* <= boolean */
Var             *pThis           /* => the variable */
);

extern void     mdlVar_setUnderDetermined
(
Var		*pThis,		/* <=> */
int		isUnderDetermined /*  => */
);

extern boolean	mdlVar_isChanged
(                               /* <= boolean */
Var             *pThis,		/*  => the variable */
double		epsilon		/*  => threshold */
);

extern boolean	mdlVar_isConstant
(                               /* <= boolean */
Var             *pThis           /* => the variable */
);

extern void	mdlVar_setConstant
(
Var		*pThis,		/* <=> */
boolean		isConstant	/*  => */
);

#endif	/* __msvvrFDF__ */
